routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', ['as' => 'home', 'uses' => 'PagesController@home'])->middleware('example');

/*Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');*/

DB::listen(function($query) {
	echo "<pre>{$query->sql}-{$query->time}</pre>";
});

Route::get('/', ['as' => 'home', 'uses' => 'PagesController@home']);

Route::get('saludos/{nombre?}', ['as' => 'saludos', 'uses' => 'PagesController@saludo'])->where('nombre', "[A-Za-z]+");

Route::resource('mensajes', 'MessagesController');
Route::resource('usuarios', 'UsersController');
Route::get('roles', function() {
	return \App\Role::with('user')->get();
});

Route::get('login', ['as' => 'login', 'uses' => 'Auth\LoginController@showLoginForm']);
Route::post('login', 'Auth\LoginController@login');
Route::get('logout', 'Auth\LoginController@logout');

/*Route::get('test', function() {
	$user = new App\User;
	$user->name = 'Jesus Roncal';
	$user->email = 'jesusroncal94@gmail.com';
	$user->password = bcrypt('123123');
	$user->save();

	return $user;
});


//Route::get('contactos', ['as' => 'contactos', 'uses' => 'PagesController@contact']);

//Route::post('contacto', 'PagesController@mensajes');

/*Route::get('mensajes', ['as' => 'messages.index', 'uses' => 'MessagesController@index']);
Route::get('mensajes/create', ['as' => 'messages.create', 'uses' => 'MessagesController@create']);
Route::post('mensajes', ['as' => 'messages.store', 'uses' => 'MessagesController@store']);
Route::get('mensajes/{id}', ['as' => 'messages.show', 'uses' => 'MessagesController@show']);
Route::get('mensajes/{id}/edit', ['as' => 'messages.edit', 'uses' => 'MessagesController@edit']);
Route::put('mensajes/{id}', ['as' => 'messages.update', 'uses' => 'MessagesController@update']);
Route::delete('mensajes/{id}', ['as' => 'messages.destroy', 'uses' => 'MessagesController@destroy']);*/

resources/views/bk_home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Dashboard</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    You are logged in!
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/contactos.blade.php
@extends('layout')


@section('contenido')

<h1>Contactos</h1>

{{--<ul>
	@foreach($lista_contactos as $contacto)
		<li>{{ $contacto }}</li>
	@endforeach--}}

	{{--@forelse($lista_contactos as $contacto)
		<li>{{ $contacto }}</li>
	@empty
		<h5>No tiene contactos :(</h5>
	@endforelse

	@if(count($lista_contactos) === 0)
		<h6>No tiene contactos :( x2</h6>
	{{--@elseif(count($lista_contactos) > 0)--}}
	{{--@@else
		<h6>Tiene varios contactos :)</h6>
	@endif
</ul>--}}

<h2>Escríbeme</h2>
@if(session()->has('info'))
	<h3>{{ session('info') }}</h3>
@else
<form method="POST" action="contacto">
	<input type="hidden" name="_token" value="{{ csrf_token() }}">
	{!! csrf_field() !!}
	<p><label for="nombre">
		Nombre
		<input type="text" name="nombre" value="{{ old('nombre') }}">
		{!! $errors->first('nombre', '<span class=error>:message</span>') !!}
	</label></p

	<p><label for="email">
		Email
		<input type="email" name="email" value="{{ old('email') }}">
		{!! $errors->first('email', '<span class=error>:message</span>') !!}
	</label></p>

	<p><label for="mensaje">
		Mensaje
		<textarea name="mensaje">{{ old('mensaje') }}</textarea>
		{!! $errors->first('mensaje', '<span class=error>:message</span>') !!}
	</label></p>

	<input type="submit" value="Enviar">
</form>
@endif

@stop

resources/views/home.blade.php
@extends('layout')


@section('contenido')

<h1>Home</h1>

@stop

resources/views/layout.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<link rel="stylesheet" href="/css/app.css">
	<title>Mi sitio</title>
</head>
<body>
	<header>
		<?php
			function activeMenu($url)
			{
				return request()->is($url) ? 'active' : '';
			}
		?>
		<div class="container">
			<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
			  <a class="navbar-brand" href="#">Menú</a>
			  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
			    <span class="navbar-toggler-icon"></span>
			  </button>
			
			  <div class="collapse navbar-collapse" id="navbarNav">
			    <ul class="navbar-nav mr-auto">
			      <li class="nav-item {{ activeMenu('/') }}">
			        <a class="nav-link" href="{{ route('home') }}">Inicio <span class="sr-only">(current)</span></a>
			      </li>
			      <li class="nav-item {{ activeMenu('saludos*') }}">
					<a class="nav-link" href="{{ route('saludos', 'Jesus') }}">Saludo</a>
			      </li>
			      <li class="nav-item {{ activeMenu('mensajes/*') }}">
					<a class="nav-link" href="{{ route('mensajes.create') }}">Contacto</a>
			      </li>
			      @if(auth()->check())
				      <li class="nav-item {{ activeMenu('mensajes') }}">
						<a class="nav-link" href="{{ route('mensajes.index') }}">Mensajes</a>
				      </li>
				      
				      @if(auth()->user()->hasRoles(['admin', 'moderador']))
					      <li class="nav-item {{ activeMenu('usuarios') }}">
							<a class="nav-link" href="{{ route('usuarios.index') }}">Usuarios</a>
					      </li>
					  @endif
			      @endif
			    </ul>
			    <ul class="navbar-nav navbar-toggler-right">
					@if(auth()->guest())
			    		<li class="nav-item {{ activeMenu('login') }}">
			    			<a class="nav-link" href="/login">Login</a>
			    		</li>
					@else
						<li class="nav-item dropdown">
							<a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
							{{ auth()->user()->name }}
							</a>
							<div class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
								<a class="dropdown-item" href="/usuarios/{{ auth()->id() }}/edit">Mi cuenta</a>
								<a class="dropdown-item" href="/logout">Logout</a>
							</div>
						</li>
			    	@endif
			    </ul>
			  </div>
			</nav>
		</div>
	</header>
	
	<br>

	<div class="container">
		@if(in_array(Route::currentRouteName(), ['mensajes.create', 'mensajes.show', 'mensajes.edit']))
			<a class="btn btn-info" href="{{ route('mensajes.index') }}">
				<<
			</a>
		@endif

		@if(in_array(Route::currentRouteName(), ['usuarios.create', 'usuarios.show', 'usuarios.edit']))
			<a class="btn btn-info" href="{{ route('usuarios.index') }}">
				<<
			</a>
		@endif

		@yield('contenido')

		<footer>
			<b>Copyright ® {{ date('Y') }}</b>
		</footer>
	</div>

	<script type="text/javascript" src="/js/app.js"></script>
</body>
</html>

resources/views/saludo.blade.php
@extends('layout')


@section('contenido')

<h1>Saludos para {{ $nombre }}</h1>

@stop